/*
 *  ======== acme/filters/FirC.xs ========
 */

var Error, Memory, Program;
 
function module$use()
{
    Error = xdc.useModule('xdc.runtime.Error');
    Memory = xdc.useModule('xdc.runtime.Memory');
    Program = xdc.useModule('xdc.cfg.Program');

    var FirC = xdc.useModule('acme.filters2.FirC');

    if (FirC.PMathOps == null) {
        if (Program.build.target.isa == "64P") {
            FirC.PMathOps = xdc.useModule('txn.mathops.MathOps64P');
        }
        else {
            FirC.PMathOps = xdc.useModule('stdsorg.math.MathOpsStd');
        }
    }
}
 
function instance$static$init(obj, coeffs, coeffsLen, params)
{
    obj.coeffs = coeffs;
    obj.coeffsLen = coeffsLen;
    obj.frameLen = params.frameLen;
 
    Memory.staticPlace(obj.history, 4, null);
    obj.history.length = historySize(obj);
}
 
function historySize(obj)    /* helper function */
{
    var sz =  Program.build.target.stdTypes.t_Int16.size;
    return (obj.coeffsLen + obj.frameLen - 1) * sz;
}
